减小数组

来源:互联网 发布:bbc有声双语新闻软件 编辑:程序博客网 时间:2024/04/30 20:15

转载网址:http://www.geeksforgeeks.org/find-minimum-possible-size-of-array-with-given-rules-for-removal/

Find minimum possible size of array with given rules for removing elements

Given an array of numbers and a constant k, minimize size of array with following rules for removing elements.

  • Exactly three elements can be removed at one go.
  • The removed three elements must be adjacent in array, i.e., arr[i], arr[i+1], arr[i+2]. And the second element must be k greater than first and third element must be k greater than second, i.e., arr[i+1] – arr[i] = k and arr[i+2]-arr[i+1] = k.

Example:

Input: arr[] = {2, 3, 4, 5, 6, 4}, k = 1Output: 0We can actually remove all elements. First remove 4, 5, 6 => We get {2, 3, 4}Now remove 2, 3, 4   => We get empty array {}Input:  arr[] = {2, 3, 4, 7, 6, 4}, k = 1Output: 3We can only remove 2 3 4

Source: https://code.google.com/codejam/contest/4214486/dashboard#s=p2

We strongly recommend you to minimize your browser and try this yourself first.
For every element arr[i] there are two possibilities
1) Either the element is not removed.
2) OR element is removed (if it follows rules of removal). When an element is removed, there are again two possibilities.
…..a) It may be removed directly, i.e., initial arr[i+1] is arr[i]+k and arr[i+2] is arr[i] + 2*k.
…..b) There exist x and y such that arr[x] – arr[i] = k, arr[y] – arr[x] = k, and subarrays “arr[i+1…x-1]” & “arr[x+1…y-1]” can be completely removed.

Below is recursive algorithm based on above idea.

// Returns size of minimum possible size of arr[low..high]// after removing elements according to given rulesfindMinSize(arr[], low, high, k)// If there are less than 3 elements in arr[low..high]1) If high-low+1 < 3, return high-low+1// Consider the case when 'arr[low]' is not considered as// part of any triplet to be removed.  Initialize result // using this case2) result = 1 + findMinSize(arr, low+1, high)// Case when 'arr[low]' is part of some triplet and removed// Try all possible triplets that have arr[low]3) For all i from low+1 to high    For all j from i+1 to high      Update result if all of the following conditions are met      a) arr[i] - arr[low] = k        b) arr[j] - arr[i]  = k      c) findMinSize(arr, low+1, i-1, k) returns 0      d) findMinSize(arr, i+1, j-1, k) also returns 0      e) Result calculated for this triplet (low, i, j)         is smaller than existing result.4) Return result

The time complexity of above solution is exponential. If we draw the complete recursion tree, we can observer that many subproblems are solved again and again. Since same suproblems are called again, this problem has Overlapping Subprolems property. Like other typical Dynamic Programming(DP) problems, recomputations of same subproblems can be avoided by constructing a temporary array dp[][] to store results of the subproblems. Below is Dynamic Programming based solution

Below is C++ implementation of above idea. The implementation is memoization based, i.e., it is recursive and uses a lookup table dp[][] to check if a subproblem is already solved or not.


// C++ program to find size of minimum possible array after
// removing elements according to given rules
#include <bits/stdc++.h>
usingnamespace std;
#define MAX 1000
 
// dp[i][j] denotes the minimum number of elements left in
// the subarray arr[i..j].
intdp[MAX][MAX];
 
intminSizeRec(intarr[], intlow, inthigh, intk)
{
    // If already evaluated
    if(dp[low][high] != -1)
        returndp[low][high];
 
    // If size of array is less than 3
    if( (high-low + 1) < 3)
        returnhigh-low +1;
 
    // Initialize result as the case when first element is
    // separated (not removed using given rules)
    intres = 1 + minSizeRec(arr, low+1, high, k);
 
    // Now consider all cases when first element forms a triplet
    // and removed. Check for all possible triplets (low, i, j)
    for(inti = low+1; i<=high-1; i++)
    {
        for(intj = i+1; j <= high; j++ )
        {
            // Check if this triplet follows the given rules of
            // removal. And elements between 'low' and 'i' , and
            //  between 'i' and 'j' can be recursively removed.
            if(arr[i] == (arr[low] + k) &&
                arr[j] == (arr[low] + 2*k) &&
                minSizeRec(arr, low+1, i-1, k) == 0 &&
                minSizeRec(arr, i+1, j-1, k) == 0)
            {
                 res = min(res, minSizeRec(arr, j+1, high, k));
            }
        }
    }
 
    // Insert value in table and return result
    return(dp[low][high] = res);
}
 
// This function mainlu initializes dp table and calls
// recursive function minSizeRec
intminSize(intarr[], intn, intk)
{
    memset(dp, -1, sizeof(dp));
    returnminSizeRec(arr, 0, n-1, k);
}
 
// Driver prrogram to test above function
intmain()
{
    intarr[] = {2, 3, 4, 5, 6, 4};
    intn = sizeof(arr)/sizeof(arr[0]);
    intk = 1;
    cout << minSize(arr, n, k) << endl;
    return0;
}



解题的思路是动态规划,启发如下:

1.递推公式取决于分水点,即分类讨论里的分类条件。这个条件分类的结果应该

是互斥的,且子集个数有限。

2.记录数据,即将已经计算出的数据保存下来,并且用标识符标记,方便下次提

取。

上面两点是解耦的,即1有很多种递推计算选择,2也有很多种存储选择。两者应

该是互不影响的。在1和2选择最优的策略时,动态规划的结果应该是最好的。


0 0